#ifndef BOARD_H
#define BOARD_H

//board variable ============================================================
static const int maxBoard = 7;
//===========================================================================

//Definition unit & color ====================================================
typedef enum PIECE {PAWN = 1, ROOK, KNIGHT, BISHOP, QUEEN, KING} PIECE;
typedef enum COLOR {WHITE = 1, BLACK} COLOR;
enum AXIS {X = 0, Y};
//============================================================================

//structure of unit ==========================================================
typedef struct unit {
	PIECE piece;
	COLOR color;
	int flag;
} unit;
//===========================================================================

//BOARD variable ============================================================
unit board[8][8];
//===========================================================================

//Declaration function *****************************************************
// Board initialization
void initBoard();

//Unit Move
int move(int old[2], int new[2]);

// All units Functions ======================================================
int outOfBoard (int new[2]);
int yourUnit (int old[2], int new[2]);
int enemyUnit (int old[2], int new[2]);
int samePlace(int old[2], int new[2]);
int performMove (int old[2], int new[2]);
//===========================================================================

// PAWN moves ===============================================================
int pawnMove (COLOR color,int flag, int old[2], int new[2]);
int goBack (COLOR color, int old, int new);
int longStep (COLOR color,int old, int new);
int twoStep (COLOR color, int old[2], int new[2]);
int oneStep (COLOR color, int old[2], int new[2]);
int pawnBecameQueen (COLOR color, int new);
// ==========================================================================

// ROOK moves ===============================================================
int rookMove (COLOR color, int flag, int old[2], int new[2]);
int notStraightMove(int old[2], int new[2]);
int unitInTheWayStraight(int old[2], int new[2]);
// ==========================================================================

// KNIGHT moves =============================================================
int knightMove (COLOR color, int flag, int old[2], int new[2]);
int notLegalKnightlMove(int old[2], int new[2]);
//===========================================================================

// BISHOP moves =============================================================
int bishopMove (COLOR color, int flag, int old[2], int new[2]);
int notDiagonalMove (int old[2], int new[2]);
int unitInTheWayDiagonal (int old[2], int new [2]);
//===========================================================================

// QUEEN moves ==============================================================
int queenMove (COLOR color, int flag, int old[2], int new[2]);
int notLegalMoveQueen (int old[2], int new[2]);
//===========================================================================

// King moves ==============================================================
int kingMove (COLOR color, int flag, int old[2], int new[2]);
int notLegalMoveKing(int old[2],int new[2]);
//===========================================================================

int performStatus(int status);


#endif
